/*
 * TextureManager.java:
 *
 * Copyright (C) 2000 John Watson, jwatson@tempusmud.com
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */
import java.io.*;
import java.util.*;

public class TextureManager {
        static String[] texnames = null;
        
        static {
                File tdir = new File( "textures" );
                if ( ! tdir.exists() || ! tdir.isDirectory() ) {
                        System.out.println( " Texture dir ./textures does not exist." );
                        texnames = new String[1];
                        texnames[0] = "null";

                }
                else {
                    String[] tmp_texnames = tdir.list();
                
                    TreeSet actual = new TreeSet();
                
                    for ( int i = 0; i < tmp_texnames.length; ++i ) {
                        if ( tmp_texnames[i].endsWith( ".png" ) ) {
                            int index = tmp_texnames[i].lastIndexOf( '.' );
                            actual.add( tmp_texnames[i].substring( 0, index ) );
                        }
                    }
                
                    texnames = new String[ actual.size() + 1 ];
                
                    texnames[0] = "null";

                    int i = 1;

                    for ( Iterator iter = actual.iterator(); iter.hasNext(); ) {
                        texnames[ i++ ] = (String) iter.next();
                    }
                }
        }

        public static String[] getTexnames() { return texnames; }
        public static String getTexname( int index ) { return texnames[index]; }
        public static int getNumTexnames() { return texnames.length; }

        public static int findTexture( String s ) {
                if ( s == null )
                        return 0;

                for ( int i = 1; i < texnames.length; ++i ) {
                        if ( s.equals( texnames[i] ) )
                                return i;
                }

                return 0;
        }
}
